
/*orismoi synarthsewn Sorted*/

#include "Sorted.h"
#include "Record.h"


int Sorted_CreateFile(char *fileName)
{int i;
 void* block;
 if (BF_CreateFile(fileName) < 0) {
	BF_PrintError("Error creating file");
	return -1;
 }
 if ((i=(BF_OpenFile(fileName))) < 0) {
	BF_PrintError("Error opening file");
	return -1;
 }
 if (BF_AllocateBlock(i) < 0) {
	BF_PrintError("Error allocating block");
	return -1;
 }
 if (BF_ReadBlock(i, 0, &block) < 0) {
	BF_PrintError("Error getting block");
	return -1;
 }
 strncpy((char*) block+500, "Sort", sizeof("Sort"));    /*apothikeuei sto proto block pliroforia pou deixnei oti to arxeio einai sorted*/
 strncpy((char*) block+500+sizeof("Sort"), "0", sizeof("0") );     /*arxikopoiei ton arithmo ton eggrafon s auto to block*/
 if (BF_WriteBlock(i, 0) < 0){
	BF_PrintError("Error writing block back");
	return -1;
 }
 if (BF_CloseFile(i) < 0) {
	BF_PrintError("Error closing file");
	return -1;
 }
 return 0;
}


int Sorted_OpenFile(char *fileName )
{int i;
 void* block;
 if ((i=(BF_OpenFile(fileName))) < 0) {
	BF_PrintError("Error opening file");
	return -1;
 }
 if (BF_ReadBlock(i, 0, &block) < 0) {
	BF_PrintError("Error getting block");
	return -1;
 }
 if (strncmp((char*) block+500, "Sort", sizeof("Sort"))==0) /*elengxei an einai arxeio taxinomimeno*/
	return i;       /*an einai epistrefei ton anagnoristiko arithmo tou fileName*/
 else
    return -1;
}


int Sorted_CloseFile(int fileDesc)
{if (BF_CloseFile(fileDesc) < 0) {
	BF_PrintError("Error closing file");
	return -1;
 }
 return 0;
}


int Sorted_InsertEntry( int fileDesc, Record record )
{int a, b, p, j, blk, rec, f, k;
 void *block, *temp;
 f=-1;
 a=0;   /*arxikopoiei ton proto oro tis dyadikis anazitisis*/
 if (BF_ReadBlock(fileDesc, BF_GetBlockCounter(fileDesc)-1, &block) < 0) {
	BF_PrintError("Error getting block");
	return -1;
 }
 for( k=2 ; (atoi((char*) block+500+sizeof("Sort"))==0) && BF_GetBlockCounter(fileDesc)>1; k++){    /*an yparxoun kena blocks proxoraei*/
	if (BF_ReadBlock(fileDesc, BF_GetBlockCounter(fileDesc)-k, &block) < 0) {                       /*mexri na vrethei block mi keno*/
		BF_PrintError("Error getting block");
		return -1;
	}
 }
 b=BF_GetBlockCounter(fileDesc)-k+1;    /*arxikopoiei ton deytero oro tis dyadikis anazitisis*/
 while ( f!=1 && a+1<b ){   /*gia oso den eimaste se diplana blocks kai to simeio eisagogis den exei vrethei*/
    blk=(a+b)/2;    /*paei sto mesaio block*/
    if (BF_ReadBlock(fileDesc, blk, &block) < 0) {
 		BF_PrintError("Error getting block");
		return -1;
	}
	rec=atoi((char*) block+500+sizeof("Sort"))-1;   /*pairnei tin teleutaia eggrafi*/
    if (memcmp((void*)((char*) block+rec*sizeof(Record)), (void*) &record, sizeof(int))==0){/*sygrinei tin teleutaia eggrafi, an to id einai iso*/
		f=1;    /*vrethike to simeio eisagogis*/
		temp=block;
		j=1;
		for (k=rec; memcmp((void*)((char*) temp+k*sizeof(Record)), (void*) &record, sizeof(int))==0 && k>-1; k--){/*oso id iso pros ta piso*/
			if (memcmp((void*)((char*) temp+k*sizeof(Record)), (void*) &record, sizeof(Record))==0){			/*elegxos gia diplotypa*/
			    printf("\nRecord (%d, %s, %s, %s) already inserted in sorted file\n",
				*((int*) ((char*)block+(k*sizeof(Record)))),
				(char*) block+(k*sizeof(Record)+sizeof(int)),
				(char*) block+(k*sizeof(Record)+sizeof(int)+sizeof(char [15])),
				(char*) block+(k*sizeof(Record)+sizeof(int)+sizeof(char [15])+sizeof(char [20])));
				return 0;
			}
			if (k==0 && blk-j>=0){  /*an elegxame k tin proti eggrafi tou trexontos block kai den eimaste sto proto block*/
			    k=9;
				if (BF_ReadBlock(fileDesc, blk-j, &temp) < 0) {
					BF_PrintError("Error getting block");
					return -1;
				}
				j++;
			}
		}
		temp=block;
		j=1;
		for (k=rec; memcmp((void*)((char*) temp+k*sizeof(Record)), (void*) &record, sizeof(int))==0 && k<9; k++){/*oso id iso pros ta mprosta*/
            if (memcmp((void*)((char*) temp+k*sizeof(Record)), (void*) &record, sizeof(Record))==0){           	/*elegxos gia diplotypa*/
			    printf("\nRecord (%d, %s, %s, %s) already inserted in sorted file\n",
				*((int*) ((char*)block+(k*sizeof(Record)))),
				(char*) block+(k*sizeof(Record)+sizeof(int)),
				(char*) block+(k*sizeof(Record)+sizeof(int)+sizeof(char [15])),
				(char*) block+(k*sizeof(Record)+sizeof(int)+sizeof(char [15])+sizeof(char [20])));
				return 0;
			}
			if (k==8 && blk+j<BF_GetBlockCounter(fileDesc)){/*an elegxame k tin teleutaia eggrafi tou trexontos block kai den eimaste sto teleutaio*/
			    k=-1;
				if (BF_ReadBlock(fileDesc, blk+j, &temp) < 0) {
					BF_PrintError("Error getting block");
					return -1;
				}
				j++;
			}
		}
	}
    else if (memcmp((void*)((char*) block+rec*sizeof(Record)), (void*) &record, sizeof(int))>0)/*an i eggrafi gia eisagogi mikroteri*/
		b=blk;  /*paei sto proto miso ton blocks*/
    else if (memcmp((void*)((char*) block+rec*sizeof(Record)), (void*) &record, sizeof(int))<0)/*an i eggrafi gia eisagogi megalyteri*/
        a=blk;  /*paei sto deytero miso ton blocks*/
 }
 if (f!=1){ /*an den vrethike to simeio eisagogis apo isotita teleutaias eggrafis*/
	 for (blk=b; blk>=a && f!=1; blk--){    /*pernoume ta dyo diplana blocks (i ena an eimaste sti arxi) pou apeminan, prota to deytero*/
	    if (BF_ReadBlock(fileDesc, blk, &block) < 0) {
	 		BF_PrintError("Error getting block");
			return -1;
		}
		p=atoi((char*) block+500+sizeof("Sort"));
		for (rec=p-1; rec>=0; rec--){   /*anatrexoume tis eggrafes ksekinontas apo tin teleytaia eggrafi k pigainontas pros ta piso*/
			if (memcmp((void*)((char*) block+rec*sizeof(Record)), (void*) &record, sizeof(int))<0){ /*an i eggrafi gia eisagogi megalyteri*/
				f=1;    /*vrethike to simeio eisagogis*/
				break;
			}
			if(memcmp((void*)((char*) block+rec*sizeof(Record)), (void*) &record, sizeof(int))==0){/*an id einai iso*/
                f=1;    /*vrethike to simeio eisagogis*/
				temp=block;
				j=1;
				for (k=rec; memcmp((void*)((char*) temp+k*sizeof(Record)), (void*) &record, sizeof(int))==0 && k>-1; k--){/*elegxos gia dyplotypa*/
					if (memcmp((void*)((char*) temp+k*sizeof(Record)), (void*) &record, sizeof(Record))==0){                /*opos pio pano*/
					    printf("\nRecord (%d, %s, %s, %s) already inserted in sorted file\n",
						*((int*) ((char*)block+(k*sizeof(Record)))),
						(char*) block+(k*sizeof(Record)+sizeof(int)),
						(char*) block+(k*sizeof(Record)+sizeof(int)+sizeof(char [15])),
						(char*) block+(k*sizeof(Record)+sizeof(int)+sizeof(char [15])+sizeof(char [20])));
						return 0;
					}
					if (k==0 && blk-j>=0){
					    k=9;
						if (BF_ReadBlock(fileDesc, blk-j, &temp) < 0) {
							BF_PrintError("Error getting block");
							return -1;
						}
						j++;
					}
				}
				temp=block;
				j=1;
				for (k=rec; memcmp((void*)((char*) temp+k*sizeof(Record)), (void*) &record, sizeof(int))==0 && k<9; k++){
		            if (memcmp((void*)((char*) temp+k*sizeof(Record)), (void*) &record, sizeof(Record))==0){
					    printf("\nRecord (%d, %s, %s, %s) already inserted in sorted file\n",
						*((int*) ((char*)block+(k*sizeof(Record)))),
						(char*) block+(k*sizeof(Record)+sizeof(int)),
						(char*) block+(k*sizeof(Record)+sizeof(int)+sizeof(char [15])),
						(char*) block+(k*sizeof(Record)+sizeof(int)+sizeof(char [15])+sizeof(char [20])));
						return 0;
					}
					if (k==8 && blk+j<BF_GetBlockCounter(fileDesc)){
					    k=-1;
						if (BF_ReadBlock(fileDesc, blk+j, &temp) < 0) {
							BF_PrintError("Error getting block");
							return -1;
						}
						j++;
					}
				}
			}
 		}
 	}
 	blk++;
 }/*se auto to simeio to blk kai to rec+1 periexoun to simeio eisagogis*/
 if (BF_ReadBlock(fileDesc, BF_GetBlockCounter(fileDesc)-1, &block) < 0) {
	BF_PrintError("Error getting block");
	return -1;
 }
 for( k=2; (atoi((char*) block+500+sizeof("Sort"))==0) && BF_GetBlockCounter(fileDesc)>1; k++){    /*an yparxoun kena blocks proxoraei*/
	if (BF_ReadBlock(fileDesc, BF_GetBlockCounter(fileDesc)-k, &block) < 0) {                       /*mexri na vrethei block mi keno*/
		BF_PrintError("Error getting block");
		return -1;
	}
 }
 for (k--; BF_GetBlockCounter(fileDesc)-k>=blk; k++){   /*paei sto teleutaio block pou yparxoun eggrafes k proxoraei pros ta piso*/
    if (BF_ReadBlock(fileDesc, BF_GetBlockCounter(fileDesc)-k, &block) < 0) {
 		BF_PrintError("Error getting block");
		return -1;
	}
	if (atoi((char*) block+500+sizeof("Sort"))==9){ /*an einai gemato*/
		if ( k==1 ){    /*k an den yparxei epomeno block keno*/
			if (BF_AllocateBlock(fileDesc) < 0) {      /*dimiourgei neo*/
				BF_PrintError("Error allocating block");
				return -1;
			}
		}
		else    /*an yparxei epomeno block keno den dimiorgei neo*/
		    k--;    /*paei ton metriti se auto*/
		if (BF_ReadBlock(fileDesc, BF_GetBlockCounter(fileDesc)-k, &temp) < 0) {    /*diavasma teleytaioy block*/
			BF_PrintError("Error getting block");
			return -1;
		}
		if (rec==8 && BF_GetBlockCounter(fileDesc)-k-1==blk){/*an to simeio eisagogis einai meta apo tin teleutaia eggrafi kai eimaste sto epomeno*/
			memcpy( temp, (void*) &record, sizeof(record) );    /*eisagei tin eggafi*/
			strncpy((char*) temp+500+sizeof("Sort"), "1", sizeof("1") );      /*kai arxikopoiei ton metriti eggrafon tou epomenou block*/
			if (BF_WriteBlock( fileDesc, BF_GetBlockCounter(fileDesc)-k ) < 0){
				BF_PrintError("Error writing block back");
				return -1;
			}
			return 0;
		}
		else{
			memcpy( temp, (void*)((char*) block+8*sizeof(Record)), sizeof(record) );    /*antigrafi teleytaias eggrafis sto epomeno block*/
			(*((char*) block+500+sizeof("Sort")))--;	/*meiosei metriti eggrafon trexontos block*/
			strncpy((char*) temp+500+sizeof("Sort"), "1", sizeof("1") );      /*kai arxikopoiei ton metriti eggrafon tou epomeno block*/
		}
		if (BF_WriteBlock( fileDesc, BF_GetBlockCounter(fileDesc)-k-1 ) < 0){
			BF_PrintError("Error writing block back");
			return -1;
		}
		if (BF_WriteBlock( fileDesc, BF_GetBlockCounter(fileDesc)-k ) < 0){
			BF_PrintError("Error writing block back");
			return -1;
		}
		k++;
	}
	if (BF_GetBlockCounter(fileDesc)-k==blk){   /*an eimaste sto block pou theloume*/
		 p=atoi((char*) block+500+sizeof("Sort"));
		 if (p!=9){ /*an den einai gemato*/
		     (*((char*) block+500+sizeof("Sort")))++;      /*auxisi arithmou eggrafon sto trexon block*/
			 for (j=p; j>rec+1; j--)	/*mexri na ftasoume sto simeio pou theloume, antigrafi eggrafon mia thesi meta*/
			    memcpy((void*)((char*) block+j*sizeof(Record)), (void*)((char*) block+(j-1)*sizeof(Record)), sizeof(Record) );
		 }
		 memcpy((void*)((char*) block+(rec+1)*sizeof(Record)), (void*)&record, sizeof(Record) );    /*eisagogi eggrafis*/
		 if (BF_WriteBlock( fileDesc, blk ) < 0){
			BF_PrintError("Error writing block back");
			return -1;
		 }
		 return 0;
	}
	else{
		p=atoi((char*) block+500+sizeof("Sort"));
		for (j=p; j>0; j--) /*mexri na ftasoume stin proti eggrafi, antigrafi eggrafon mia thesi meta */
	    	memcpy((void*)((char*) block+j*sizeof(Record)), (void*)((char*) block+(j-1)*sizeof(Record)), sizeof(Record) );
		if (rec==8 && BF_GetBlockCounter(fileDesc)-k-1==blk){/*an to simeio eisagogis einai meta apo tin teleutaia eggrafi kai eimaste sto epomeno*/
	        memcpy( block, (void*) &record, sizeof(Record) );   /*eisagei ti eggrafi*/
			(*((char*) block+500+sizeof("Sort")))++;      /*auxisi arithmou eggrafon sto trexon block*/
		 	if (BF_WriteBlock( fileDesc, BF_GetBlockCounter(fileDesc)-k ) < 0){
				BF_PrintError("Error writing block back");
				return -1;
		 	}
		 	return 0;
		}
		if (BF_ReadBlock(fileDesc, BF_GetBlockCounter(fileDesc)-k-1, &temp) < 0) {
			BF_PrintError("Error getting block");
			return -1;
		}
	 	memcpy( block, (void*)((char*) temp+8*sizeof(Record)), sizeof(Record) );    /*antigrafi teleytaias eggrafis sto epomeno block*/
	 	(*((char*) temp+500+sizeof("Sort")))--;     /*meiosei arithmou eggrafon sto epomeno*/
		(*((char*) block+500+sizeof("Sort")))++;      /*auxisi arithmou eggrafon sto trexon block*/
	 	if (BF_WriteBlock( fileDesc, BF_GetBlockCounter(fileDesc)-k ) < 0){
			BF_PrintError("Error writing block back");
			return -1;
	 	}
	 	if (BF_WriteBlock( fileDesc, BF_GetBlockCounter(fileDesc)-k-1 ) < 0){
			BF_PrintError("Error writing block back");
			return -1;
	 	}
	}
 }
 return -1;
}


int Sorted_DeleteEntry ( int fileDesc, char* fieldName, void *value )
{int a, b, p, blk, rec, i, j, k, l, f, t, fn;
 void* block, *temp;
 if (strncmp(fieldName, "id", sizeof("id"))==0){    /*an kanoume diagrafi me vasi to id*/
	 t=(int) value;
	 f=-1;
	 a=0;	/*arxikopoiei ton proto oro tis dyadikis anazitisis*/
	 if (BF_ReadBlock(fileDesc, BF_GetBlockCounter(fileDesc)-1, &block) < 0) {
		BF_PrintError("Error getting block");
		return -1;
	 }
	 for( k=2 ; (atoi((char*) block+500+sizeof("Sort"))==0) && BF_GetBlockCounter(fileDesc)>1; k++){    /*an yparxoun kena blocks proxoraei*/
		if (BF_ReadBlock(fileDesc, BF_GetBlockCounter(fileDesc)-k, &block) < 0) {                       /*mexri na vrethei block mi keno*/
			BF_PrintError("Error getting block");
			return -1;
		}
	 }
	 b=BF_GetBlockCounter(fileDesc)-k+1;    /*arxikopoiei ton deytero oro tis dyadikis anazitisis*/
	 while ( f!=1 && a+1<b ){   /*gia oso den eimaste se diplana blocks kai i eggrafi gia diagrafi den exei vrethei*/
	    blk=(a+b)/2;    /*paei sto mesaio block*/
	    if (BF_ReadBlock(fileDesc, blk, &block) < 0) {
	 		BF_PrintError("Error getting block");
			return -1;
		}
		rec=atoi((char*) block+500+sizeof("Sort"))-1;   /*pairnei tin teleutaia eggrafi*/
	    if (memcmp((void*)((char*) block+rec*sizeof(Record)), (void*) &t, sizeof(int))==0)  /*sygrinei tin teleutaia eggrafi, an to id einai iso*/
            f=1;    /*vrethike i eggrafi gia diagrafi*/
	    else if (memcmp((void*)((char*) block+rec*sizeof(Record)), (void*) &t, sizeof(int))>0)	/*an i eggrafi gia diagrafi mikroteri*/
			b=blk;  /*paei sto proto miso ton blocks*/
	    else if (memcmp((void*)((char*) block+rec*sizeof(Record)), (void*) &t, sizeof(int))<0)  /*an i eggrafi gia eisagogi megalyteri*/
	        a=blk;  /*paei sto deytero miso ton blocks*/
	 }
	 if (f!=1){ /*an den vrethike i eggrafi gia diagrafi apo isotita teleutaias eggrafis*/
		 for (blk=b; blk>=a && f!=1; blk--){    /*pernoume ta dyo diplana blocks (i ena an eimaste sti arxi) pou apeminan, prota to deytero*/
		    if (BF_ReadBlock(fileDesc, blk, &block) < 0) {
		 		BF_PrintError("Error getting block");
				return -1;
			}
			p=atoi((char*) block+500+sizeof("Sort"));
			for (rec=p-1; rec>=0; rec--)    /*anatrexoume tis eggrafes ksekinontas apo tin teleytaia eggrafi k pigainontas pros ta piso*/
				if(memcmp((void*)((char*) block+rec*sizeof(Record)), (void*) &t, sizeof(int))==0){  /*an id einai iso*/
                    f=1;    /*vrethike i eggrafi gia diagrafi*/
                    break;
				}
	 	}
	 	blk++;
	}/*se auto to simeio to blk kai to rec periexoun to simeio me tin eggrafi pou einai gia diagrafi*/
 	temp=block;
	l=1;
	for (i=rec; memcmp((void*)((char*) temp+i*sizeof(Record)), (void*) &t, sizeof(int))==0 && i>-1; i--){	/*elegxos pros ta piso gia diagrafi*/
        p=atoi((char*) temp+500+sizeof("Sort"));                                                            /*k allon eggrafon me id iso me value*/
		for (j=i; j<p; j++){  /*gia tis eggrafes tou block pou yparxei i eggrafi pou theloume na svisoume*/
			if (j==p-1){	/*an eimaste stin teleutaia eggrafi tou trexontos block*/
				if (j==8 && (blk-l+1)!=BF_GetBlockCounter(fileDesc)-1){/*an den eimaste sto teleytaio block me eggrafes*/
					if (BF_ReadBlock(fileDesc, blk-l+2, &block) < 0) {  /*pernei to epomeno block*/
						BF_PrintError("Error getting block");
						return -1;
					}
					if (atoi((char*) block+500+sizeof("Sort"))!=0){ /*an den einai adeio*/
						memcpy( (void*)((char*) temp+j*sizeof(Record)), block, sizeof(Record) );/*antigrafi protis eggrafis sto telos*/
						if (atoi((char*) block+500+sizeof("Sort"))==1){ /*an exei mia eggrafi*/
                            memset ( (void*) ((char*)block+sizeof(Record)*j), '\0', sizeof(Record) );    /*svisimo teleutaias eggrafis*/
                            (*((char*) block+500+sizeof("Sort")))--;    /*meiosi tou metriti eggrafon tou epomenou block*/
                            if (BF_WriteBlock( fileDesc, blk-l+2 ) < 0){
								BF_PrintError("Error writing block back");
								return -1;
							}
						}
					}
					else{
						memset ( (void*) ((char*)temp+sizeof(Record)*j), '\0', sizeof(Record) );    /*svisimo teleutaias eggrafis*/
						(*((char*) temp+500+sizeof("Sort")))--;   /*meiosi tou metriti eggrafon tou trexontos block*/
					}
				}
				else{
					memset ( (void*) ((char*)temp+sizeof(Record)*j), '\0', sizeof(Record) );    /*svisimo teleutaias eggrafis*/
					(*((char*) temp+500+sizeof("Sort")))--;   /*meiosi tou metriti eggrafon tou trexontos block*/
				}
			}
			else    /*an den eimaste stin teleutaia eggrafi metakini eggafis mia thesi prin*/
               	memcpy( (void*)((char*) temp+j*sizeof(Record)), (void*)((char*) temp+(j+1)*sizeof(Record)), sizeof(Record) );
        	if (BF_WriteBlock( fileDesc, blk-l+1 ) < 0){
					BF_PrintError("Error writing block back");
					return -1;
			}
		}
		for (k=blk-l+2; k<BF_GetBlockCounter(fileDesc) ; k++){/*gia tis eggrafes ton epomenon blocks kanei tin idia diadikasia me prin*/
		    if (BF_ReadBlock(fileDesc, k, &temp) < 0) {
		 		BF_PrintError("Error getting block");
				return -1;
			}
			p=atoi((char*) temp+500+sizeof("Sort"));
			for (j=0; j<p; j++){
				if (j==p-1){
					if (j==8 && k!=BF_GetBlockCounter(fileDesc)-1){
						if (BF_ReadBlock(fileDesc, k+1, &block) < 0) {
							BF_PrintError("Error getting block");
							return -1;
						}
						if (atoi((char*) block+500+sizeof("Sort"))!=0){
							memcpy( (void*)((char*) temp+j*sizeof(Record)), block, sizeof(Record) );
							if (atoi((char*) block+500+sizeof("Sort"))==1){
                                memset ( (void*) ((char*)block+sizeof(Record)*j), '\0', sizeof(Record) );    /*svisimo teleutaias eggrafis*/
	                            (*((char*) block+500+sizeof("Sort")))--;
	                            if (BF_WriteBlock( fileDesc, k+1 ) < 0){
									BF_PrintError("Error writing block back");
									return -1;
								}
							}
						}
						else{
							memset ( (void*) ((char*)temp+sizeof(Record)*j), '\0', sizeof(Record) );    /*svisimo teleutaias eggrafis*/
							(*((char*) temp+500+sizeof("Sort")))--;   /*meiosi tou metriti eggrafon tou trexontos block*/
						}
					}
					else{
						memset ( (void*) ((char*)temp+sizeof(Record)*j), '\0', sizeof(Record) );    /*svisimo teleutaias eggrafis*/
						(*((char*) temp+500+sizeof("Sort")))--;   /*meiosi tou metriti eggrafon tou trexontos block*/
					}
				}
				else
	                memcpy( (void*)((char*) temp+j*sizeof(Record)), (void*)((char*) temp+(j+1)*sizeof(Record)), sizeof(Record) );
            	if (BF_WriteBlock( fileDesc, k ) < 0){
						BF_PrintError("Error writing block back");
						return -1;
				}
			}
		}
		if (BF_ReadBlock(fileDesc, blk-l+1, &temp) < 0) {
			BF_PrintError("Error getting block");
			return -1;
		}
		if (i==0 && blk-l>=0){  /*an elegxame k tin proti eggrafi tou trexontos block kai den eimaste sto proto block*/
		    i=9;
			if (BF_ReadBlock(fileDesc, blk-l, &temp) < 0) {
				BF_PrintError("Error getting block");
				return -1;
			}
			l++;
		}
	}
	blk=blk-l+1;
	l=1;
	if (i==8 && blk+l<BF_GetBlockCounter(fileDesc)){/*an elegxame k tin teleutaia eggrafi tou trexontos block kai den eimaste sto teleutaio*/
	    i=-1;
		if (BF_ReadBlock(fileDesc, blk+l, &temp) < 0) {
			BF_PrintError("Error getting block");
			return -1;
		}
		l++;
	}
	for (i++; memcmp((void*)((char*) temp+i*sizeof(Record)), (void*) &t, sizeof(int))==0 && i<9; ){/*idia diadikasia pros ta mprosta*/
		p=atoi((char*) temp+500+sizeof("Sort"));
		for (j=i; j<p; j++){
			if (j==p-1){
				if (j==8 && (blk+l-1)!=BF_GetBlockCounter(fileDesc)-1){
					if (BF_ReadBlock(fileDesc, blk+l, &block) < 0) {
						BF_PrintError("Error getting block");
						return -1;
					}
					if (atoi((char*) block+500+sizeof("Sort"))!=0){
						memcpy( (void*)((char*) temp+j*sizeof(Record)), block, sizeof(Record) );
						if (atoi((char*) block+500+sizeof("Sort"))==1){
                            memset ( (void*) ((char*)block+sizeof(Record)*j), '\0', sizeof(Record) );    
                            (*((char*) block+500+sizeof("Sort")))--;
                            if (BF_WriteBlock( fileDesc, blk+l ) < 0){
								BF_PrintError("Error writing block back");
								return -1;
							}
						}
					}
					else{
						memset ( (void*) ((char*)temp+sizeof(Record)*j), '\0', sizeof(Record) );
						(*((char*) temp+500+sizeof("Sort")))--;
					}
				}
				else{
					memset ( (void*) ((char*)temp+sizeof(Record)*j), '\0', sizeof(Record) );
					(*((char*) temp+500+sizeof("Sort")))--;
				}
			}
			else
               	memcpy( (void*)((char*) temp+j*sizeof(Record)), (void*)((char*) temp+(j+1)*sizeof(Record)), sizeof(Record) );
        	if (BF_WriteBlock( fileDesc, blk+l-1 ) < 0){
					BF_PrintError("Error writing block back");
					return -1;
			}
		}
		for (k=blk+l; k<BF_GetBlockCounter(fileDesc) ; k++){
		    if (BF_ReadBlock(fileDesc, k, &temp) < 0) {
		 		BF_PrintError("Error getting block");
				return -1;
			}
			p=atoi((char*) temp+500+sizeof("Sort"));
			for (j=0; j<p; j++){
				if (j==p-1){
					if (j==8 && k!=BF_GetBlockCounter(fileDesc)-1){
						if (BF_ReadBlock(fileDesc, k+1, &block) < 0) {
							BF_PrintError("Error getting block");
							return -1;
						}
						if (atoi((char*) block+500+sizeof("Sort"))!=0){
							memcpy( (void*)((char*) temp+j*sizeof(Record)), block, sizeof(Record) );
							if (atoi((char*) block+500+sizeof("Sort"))==1){
                                memset ( (void*) ((char*)block+sizeof(Record)*j), '\0', sizeof(Record) );
	                            (*((char*) block+500+sizeof("Sort")))--;
	                            if (BF_WriteBlock( fileDesc, k+1 ) < 0){
									BF_PrintError("Error writing block back");
									return -1;
								}
							}
						}
						else{
							memset ( (void*) ((char*)temp+sizeof(Record)*j), '\0', sizeof(Record) );
							(*((char*) temp+500+sizeof("Sort")))--;
						}
					}
					else{
						memset ( (void*) ((char*)temp+sizeof(Record)*j), '\0', sizeof(Record) );
						(*((char*) temp+500+sizeof("Sort")))--;
					}
				}
				else
	                memcpy( (void*)((char*) temp+j*sizeof(Record)), (void*)((char*) temp+(j+1)*sizeof(Record)), sizeof(Record) );
            	if (BF_WriteBlock( fileDesc, k ) < 0){
						BF_PrintError("Error writing block back");
						return -1;
				}
			}
		}
		if (BF_ReadBlock(fileDesc, blk+l-1, &temp) < 0) {
			BF_PrintError("Error getting block");
			return -1;
		}
		if (i==8 && blk+l<BF_GetBlockCounter(fileDesc)){/*an elegxame k tin teleutaia eggrafi tou trexontos block kai den eimaste sto teleutaio*/
		    i=0;
			if (BF_ReadBlock(fileDesc, blk+l, &temp) < 0) {
				BF_PrintError("Error getting block");
				return -1;
			}
			l++;
		}
	}
	return 0;
 }
 else if (strncmp(fieldName, "name", sizeof("name"))==0)    /*analoga to fieldName o deikteis tha kinithei antistoixa ston elengxo*/
    fn=sizeof(int);
 else if (strncmp(fieldName, "surname", sizeof("surname"))==0)
    fn=sizeof(int)+sizeof(char [15]);
 else if (strncmp(fieldName, "city", sizeof("city"))==0)
    fn=sizeof(int)+sizeof(char [15])+sizeof(char [20]);
 for ( blk=0 ; blk<BF_GetBlockCounter(fileDesc) ; blk++){ /*anatrexei ola ta blocks*/
	if (BF_ReadBlock(fileDesc, blk, &temp) < 0) {
 		BF_PrintError("Error getting block");
		return -1;
	}
	for ( rec=0 ; rec<atoi((char*) temp+500+sizeof("Sort")) ; rec++){   /*kai oles tis eggrafes tou kathe block*/
        if (memcmp( (void*) ((char*) temp+(rec*sizeof(Record)+fn)), value, sizeof(value) )==0){   /*elengxos tou value pou zitithike*/
			p=atoi((char*) temp+500+sizeof("Sort"));
			for (j=rec; j<p; j++){  /*diadikasia metakinisis ton eggrafon meta apo auto pou diagrafetai mia thesi pio piso opos pio pano*/
				if (j==p-1){
					if (j==8 && blk!=BF_GetBlockCounter(fileDesc)-1){
						if (BF_ReadBlock(fileDesc, blk+1, &block) < 0) {
							BF_PrintError("Error getting block");
							return -1;
						}
						if (atoi((char*) block+500+sizeof("Sort"))!=0){
							memcpy( (void*)((char*) temp+j*sizeof(Record)), block, sizeof(Record) );
							if (atoi((char*) block+500+sizeof("Sort"))==1){
                                memset ( (void*) ((char*)block+sizeof(Record)*j), '\0', sizeof(Record) );
	                            (*((char*) block+500+sizeof("Sort")))--;
	                            if (BF_WriteBlock( fileDesc, blk+1 ) < 0){
									BF_PrintError("Error writing block back");
									return -1;
								}
							}
						}
						else{
							memset ( (void*) ((char*)temp+sizeof(Record)*j), '\0', sizeof(Record) );
							(*((char*) temp+500+sizeof("Sort")))--;
						}
					}
					else{
						memset ( (void*) ((char*)temp+sizeof(Record)*j), '\0', sizeof(Record) );
						(*((char*) temp+500+sizeof("Sort")))--;
					}
				}
				else
	               	memcpy( (void*)((char*) temp+j*sizeof(Record)), (void*)((char*) temp+(j+1)*sizeof(Record)), sizeof(Record) );
	        	if (BF_WriteBlock( fileDesc, blk ) < 0){
						BF_PrintError("Error writing block back");
						return -1;
				}
			}
			for (k=blk+1; k<BF_GetBlockCounter(fileDesc) ; k++){
			    if (BF_ReadBlock(fileDesc, k, &temp) < 0) {
			 		BF_PrintError("Error getting block");
					return -1;
				}
				p=atoi((char*) temp+500+sizeof("Sort"));
				for (j=0; j<p; j++){
					if (j==p-1){
						if (j==8 && k!=BF_GetBlockCounter(fileDesc)-1){
							if (BF_ReadBlock(fileDesc, k+1, &block) < 0) {
								BF_PrintError("Error getting block");
								return -1;
							}
							if (atoi((char*) block+500+sizeof("Sort"))!=0){
								memcpy( (void*)((char*) temp+j*sizeof(Record)), block, sizeof(Record) );
								if (atoi((char*) block+500+sizeof("Sort"))==1){
                                    memset ( (void*) ((char*)block+sizeof(Record)*j), '\0', sizeof(Record) );
		                            (*((char*) block+500+sizeof("Sort")))--;
		                            if (BF_WriteBlock( fileDesc, k+1 ) < 0){
										BF_PrintError("Error writing block back");
										return -1;
									}
								}
							}
							else{
								memset ( (void*) ((char*)temp+sizeof(Record)*j), '\0', sizeof(Record) );
								(*((char*) temp+500+sizeof("Sort")))--;
							}
						}
						else{
							memset ( (void*) ((char*)temp+sizeof(Record)*j), '\0', sizeof(Record) );
							(*((char*) temp+500+sizeof("Sort")))--;
						}
					}
					else
		                memcpy( (void*)((char*) temp+j*sizeof(Record)), (void*)((char*) temp+(j+1)*sizeof(Record)), sizeof(Record) );
	            	if (BF_WriteBlock( fileDesc, k ) < 0){
							BF_PrintError("Error writing block back");
							return -1;
					}
				}
			}
			rec--;  /*meiosi tou deikti gia na elegxthei kai i eggrafi pou metakinithike*/
			if (BF_ReadBlock(fileDesc, blk, &temp) < 0) {
	 			BF_PrintError("Error getting block");
				return -1;
			}
		}
	}
 }
 return 0;
}


void Sorted_GetAllEntries( int fileDesc, char* fieldName, void *value )
{int a, b, p, blk, rec, i, k, l, f, t, c, fn;
 void* block;
 if ( value==NULL ){
    for ( blk=0 ; blk<BF_GetBlockCounter(fileDesc) ; blk++){  /*anatrexei ola ta blocks*/
		if (BF_ReadBlock(fileDesc, blk, &block) < 0) {
 			BF_PrintError("Error getting block");
		}
		for ( rec=0 ; rec<atoi((char*) block+500+sizeof("Sort")) ; rec++){   /*kai oles tis eggrafes tou kathe block*/
			printf("ID: %-4d NAME: %-15s SURNAME: %-20s CITY: %-10s\n",
			*((int*) ((char*)block+(rec*sizeof(Record)))),
			(char*) block+(rec*sizeof(Record)+sizeof(int)),
			(char*) block+(rec*sizeof(Record)+sizeof(int)+sizeof(char [15])),
			(char*) block+(rec*sizeof(Record)+sizeof(int)+sizeof(char [15])+sizeof(char [20])));
		}
	 }
	 printf("%d blocks were read.\n",blk);
	 return;
 }
 else if (strncmp(fieldName, "id", sizeof("id"))==0){   /*an kanoume ektyposi me vasi to id*/
	 c=0;
	 f=-1;
	 t=(int) value;
	 a=0;	/*arxikopoiei ton proto oro tis dyadikis anazitisis*/
	 if (BF_ReadBlock(fileDesc, BF_GetBlockCounter(fileDesc)-1, &block) < 0)
		BF_PrintError("Error getting block");
	 for( k=2 ; (atoi((char*) block+500+sizeof("Sort"))==0) && BF_GetBlockCounter(fileDesc)>1; k++)   	/*an yparxoun kena blocks proxoraei*/
		if (BF_ReadBlock(fileDesc, BF_GetBlockCounter(fileDesc)-k, &block) < 0)                         /*mexri na vrethei block mi keno*/
			BF_PrintError("Error getting block");
	 b=BF_GetBlockCounter(fileDesc)-k+1;    /*arxikopoiei ton deytero oro tis dyadikis anazitisis*/
	 while ( f!=1 && a+1<b ){	/*gia oso den eimaste se diplana blocks kai i eggrafi gia diagrafi den exei vrethei*/
	    blk=(a+b)/2;    /*paei sto mesaio block*/
	    if (BF_ReadBlock(fileDesc, blk, &block) < 0)
	 		BF_PrintError("Error getting block");
		c++;    /*auxisi ton blocks pou diavastikan*/
		rec=atoi((char*) block+500+sizeof("Sort"))-1;   /*pairnei tin teleutaia eggrafi*/
	    if (memcmp((void*)((char*) block+rec*sizeof(Record)), (void*) &t, sizeof(int))==0)  /*sygrinei tin teleutaia eggrafi, an to id einai iso*/
            f=1;    /*vrethike i eggrafi gia ektyposi*/
	    else if (memcmp((void*)((char*) block+rec*sizeof(Record)), (void*) &t, sizeof(int))>0)  /*an i eggrafi gia diagrafi mikroteri*/
			b=blk;  /*paei sto proto miso ton blocks*/
	    else if (memcmp((void*)((char*) block+rec*sizeof(Record)), (void*) &t, sizeof(int))<0)  /*an i eggrafi gia eisagogi megalyteri*/
	        a=blk;  /*paei sto deytero miso ton blocks*/
	 }
	 if (f!=1){ /*an den vrethike i eggrafi gia ektyposi apo isotita teleutaias eggrafis*/
		 for (blk=b; blk>=a && f!=1; blk--){    /*pernoume ta dyo diplana blocks (i ena an eimaste sti arxi) pou apeminan, prota to deytero*/
			if (BF_ReadBlock(fileDesc, blk, &block) < 0)
		 		BF_PrintError("Error getting block");
			c++;    /*auxisi ton blocks pou diavastikan*/
			p=atoi((char*) block+500+sizeof("Sort"));
			for (rec=p-1; rec>=0; rec--)    /*anatrexoume tis eggrafes ksekinontas apo tin teleytaia eggrafi k pigainontas pros ta piso*/
				if(memcmp((void*)((char*) block+rec*sizeof(Record)), (void*) &t, sizeof(int))==0){  /*an id einai iso*/
                    f=1;    /*vrethike i eggrafi gia ektyposi*/
                    break;
				}
	 	}
	 	blk++;
	}
	l=1;
	for (i=rec; memcmp((void*)((char*) block+i*sizeof(Record)), (void*) &t, sizeof(int))==0 && i>-1; i--){/*elegxos pros ta piso gia idio id*/
    	printf("ID: %-4d NAME: %-15s SURNAME: %-20s CITY: %-10s\n",
		*((int*) ((char*)block+(i*sizeof(Record)))),
		(char*) block+(i*sizeof(Record)+sizeof(int)),
		(char*) block+(i*sizeof(Record)+sizeof(int)+sizeof(char [15])),
		(char*) block+(i*sizeof(Record)+sizeof(int)+sizeof(char [15])+sizeof(char [20])));
		if (BF_ReadBlock(fileDesc, blk-l+1, &block) < 0)
			BF_PrintError("Error getting block");
		if (i==0 && blk-l>=0){	/*an elegxame k tin proti eggrafi tou trexontos block kai den eimaste sto proto block*/
		    i=9;
			if (BF_ReadBlock(fileDesc, blk-l, &block) < 0)
				BF_PrintError("Error getting block");
            c++;
			l++;
		}
	}
	if (BF_ReadBlock(fileDesc, blk, &block) < 0)
 		BF_PrintError("Error getting block");
	l=1;
	if (rec==8 && blk+l<BF_GetBlockCounter(fileDesc)){
	    rec=-1;
		if (BF_ReadBlock(fileDesc, blk+l, &block) < 0)
			BF_PrintError("Error getting block");
        c++;
		l++;
	}
	for (i=rec+1; memcmp((void*)((char*) block+i*sizeof(Record)), (void*) &t, sizeof(int))==0 && i<9; i++){/*elegxos pros ta mprosta gia idio id*/
		printf("ID: %-4d NAME: %-15s SURNAME: %-20s CITY: %-10s\n",
		*((int*) ((char*)block+(i*sizeof(Record)))),
		(char*) block+(i*sizeof(Record)+sizeof(int)),
		(char*) block+(i*sizeof(Record)+sizeof(int)+sizeof(char [15])),
		(char*) block+(i*sizeof(Record)+sizeof(int)+sizeof(char [15])+sizeof(char [20])));
		if (BF_ReadBlock(fileDesc, blk+l-1, &block) < 0)
			BF_PrintError("Error getting block");
		if (i==8 && blk+l<BF_GetBlockCounter(fileDesc)){
		    i=-1;
			if (BF_ReadBlock(fileDesc, blk+l, &block) < 0)
				BF_PrintError("Error getting block");
            c++;
			l++;
		}
	}
	printf("%d blocks were read.\n",c);
	return;
 }
 else if (strncmp(fieldName, "name", sizeof("name"))==0)    /*analoga to fieldName o deikteis tha kinithei antstoixa ston elengxo*/
 	fn=sizeof(int);
 else if (strncmp(fieldName, "surname", sizeof("surname"))==0)
	fn=sizeof(int)+sizeof(char [15]);
 else if (strncmp(fieldName, "city", sizeof("city"))==0)
	fn=sizeof(int)+sizeof(char [15])+sizeof(char [20]);
 for ( blk=0 ; blk<BF_GetBlockCounter(fileDesc) ; blk++){   /*anatrexei ola ta blocks*/
	if (BF_ReadBlock(fileDesc, blk, &block) < 0) {
		BF_PrintError("Error getting block");
	}
	for ( rec=0 ; rec<atoi((char*) block+500+sizeof("Sort")) ; rec++){  /*kai oles tis eggrafes tou kathe block*/
  	  if (strncmp( (char*) block+(rec*sizeof(Record)+fn), value, sizeof(value) )==0){   /*elengxos tou value pou zitithike*/
			printf("ID: %-4d NAME: %-15s SURNAME: %-20s CITY: %-10s\n",
			*((int*) ((char*)block+(rec*sizeof(Record)))),
			(char*) block+(rec*sizeof(Record)+sizeof(int)),
			(char*) block+(rec*sizeof(Record)+sizeof(int)+sizeof(char [15])),
			(char*) block+(rec*sizeof(Record)+sizeof(int)+sizeof(char [15])+sizeof(char [20])));
		}
	}
 }
 printf("%d blocks were read.\n",blk);
 return;
}
